vDataJSON.tpl.html = `
<!DOCTYPE html>
<html >
<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="jsoneditor4menu" content="https://niehausbert.gitlab.io/jsoneditor4menu">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>{{data.appname}} - WebApp</title>
  <link rel="stylesheet" href="css/normalize.min.css">
  <link rel="stylesheet" href="css/jquery-ui.css">
  <!-- generated CSS files by jsoneditor4menu -->
{{#foreach settings.cssfiles data}}
  <link rel="stylesheet" href="{{{filepath}}}">
{{/foreach}}


</head>

<body>

    <div class="wrapper">
        <nav class="site-nav">
            <h1 class="logo">WebApp<span> Navigation</span></h1>

            <div class="menu-toggle">
              <div class="hamburger"></div>
            </div>

            <ul class="open desktop">
{{#foreach data.menuitems data}}
                <!-- Menu Item '{{title}}' - type: {{menutype}} - visibility: {{{visibility}}} -->
{{#ifcond visibility "==" "visible"}}
{{#ifcond menutype "==" "jscall"}}
                <li><a href="#!" onclick="app.evt.{{filename title}}()"><img class="menu-icon" src="img/icons-svg/{{{menuicon}}}-white.svg"><div class="nav-text site-nav--icon">{{{title}}}</div></a></li>
{{/ifcond}}
{{#ifcond menutype "==" "page"}}
                <li><a href="#!" onclick="app.nav.page('{{filename title}}')"><img class="menu-icon" src="img/icons-svg/{{{menuicon}}}-white.svg"><div class="nav-text site-nav--icon">{{{title}}}</div></a></li>
{{/ifcond}}
{{#ifcond menutype "==" "link"}}
                <li><a href="{{{url}}}" {{{target}}}><img class="menu-icon" src="img/icons-svg/{{{menuicon}}}-white.svg"><div class="nav-text site-nav--icon">{{{title}}}</div></a></li>
{{/ifcond}}
{{/ifcond}}
{{/foreach}}
            </ul>
        </nav>
    </div>
    <div class="area" data-role="page-container" id="page-container" currentpage="home">
{{#foreach data.menuitems data}}
{{#ifcond menutype "==" "page"}}
{{#ifcond visibility "!=" "not used"}}
      <div class="pages-app" data-role="page" id="{{filename title}}">
        <h2>{{{title}}}</h2>
{{indent content "			    "}}

      </div>
{{/ifcond}}
{{/ifcond}}
{{/foreach}}
    </div>



  <!-- Generate script tags for all files in 'settings.jsfiles' -->
{{#foreach settings.jsfiles data}}
  <!-- {{{filepath}}} is generated by JSONEditor4Menu -->
  <script src="{{{filepath}}}"></script>
{{/foreach}}
  <script>
    // Config Code is defined in settings.configcode by JSONEditor4Menu
{{{indent settings.configcode "      "}}}
  </script>
</body>
</html>

`;

// NodeJS: uncomment modules.export in last line
// module.export = {{classname}};
